var canvas;
var cntx;
var cnvBackBuffer;
var cntxBackBuffer;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    cnvBackBuffer=document.getElementById("backBuffer");
    cntxBackBuffer=cnvBackBuffer.getContext("2d");
    showAppTitle();
    
    imgLogo=document.getElementById("Logo");
    img=document.getElementById("imgToShow");
    
    initialValues();
    InitialiseCaptions();
    for(var i=0;i<NoOfCategories;i++){
        SelectedImage[i]=0;
    }
    InitialiseImageFileNames();
    initialiseGUI();
    nxtStepLeft=8;
    nxtStepTop=BottomPanelTop+20;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");

    initialiseEvents();
    drawBasicScreen();
}
    
function initialiseEvents(){
    $("#visualisation").contextmenu(function(evt){
        evt.preventDefault();
        evt.stopPropagation();
    });
    
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove(evt);
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp(evt);
    });
    
    $("#visualisation").on("mouseout",function(evt){
        imgLogo=document.getElementById("Logo");
        drawBasicScreen();
    });
}

function InitialiseImageFileNames(){
    FileName[0]="BTNEnjoyment";
    FileName[1]="BTNNews";
    FileName[2]="BTNEducation";
    FileName[3]="BTNInfo";          
}

function initialValues(){
    width=canvas.width;
    height=canvas.height;
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-10;
    logoTop=BottomPanelTop+10;
    SectionTitle=BottomPanelTop-20;
    BTNTop=TopPanelHeight+Column1Left;
}

function initialiseGUI(){
    logoLeft=width-logoWidth-10;
    logoTop=BottomPanelTop+10;
    imgLogo=document.getElementById("Logo");
    for(var i=0;i<NoOfCategories;i++){
        imgButtons[i]=document.getElementById(FileName[i]+"2");
        imgButtonsHovered[i]=document.getElementById(FileName[i]+"1");
        ButtonHover[i]=false;
    }
    InitialiseGUI_values();
}

function InitialiseGUI_values(){
    ImageTop=TopPanelHeight+imgButtons[0].height+Column1Top;
}

function drawBasicScreen(){
    //Φόντα οθόνης
    cntx.clearRect(0,0,canvas.width,canvas.height);
    
    cntx.fillStyle=MainAreaColor;
    cntx.fillRect(0,0,width,height);

    cntx.fillStyle=PanelColor;
    cntx.fillRect(0,0,width,TopPanelHeight);
    cntx.fillRect(0,BottomPanelTop,width,BottomPanelHeight);
    //Τίτλος εφαρμογής
    cnvsWrite(LetterColor,30,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    //Κουμπιά
    for(var i=0;i<NoOfCategories;i++){
        if (ButtonHover[i]){
            cntx.drawImage(imgButtonsHovered[i],ButtonLeft(i),BTNTop);
        }
        else {
            cntx.drawImage(imgButtons[i],ButtonLeft(i),BTNTop);
        }
    }
    drawButtonNext();

    //Εικόνες
    var imgMainLeft=(width-iw)/2;
    var imgMainTop=(SectionTitle-ImageTop-ih)/2+ImageTop;
    
    cntxBackBuffer.drawImage(img,0,0);
    ShowCaption();

    if(iw>0){
    	imgData=cntxBackBuffer.getImageData(0,0,iw,ih);
    	if(DrawingFinished){
            cntx.putImageData(imgData,imgMainLeft,imgMainTop);
    	}
    	else{
            timerLoop=setInterval(
                    function(){
                        drawSelectedImage(imgMainLeft,imgMainTop);
                    },
                    simSpeed);
    	}
    }
    
    cnvsWrite(LetterColor,fontSize-10,"Arial",-1,BottomPanelTop+67,"Κάνε διαδοχικά κλικ σε μια κατηγορία για να δεις ένα νέο παράδειγμα.");    

    //Πλαίσια μαύρου χρώματος
    cntx.strokeStyle="rgb(0,0,0)";
    cntx.beginPath();
    cntx.rect(0,0,width-1,TopPanelHeight);
    cntx.rect(0,TopPanelHeight,width-1,height-TopPanelHeight-BottomPanelHeight);
    cntx.rect(0,BottomPanelTop,width-1,BottomPanelHeight-1);
    if(iw>0){
        cntx.rect(imgMainLeft-1,imgMainTop-1,iw+1,ih+1);
    }
    cntx.stroke();
    cntx.drawImage(imgLogo,logoLeft,logoTop);
}

function drawSelectedImage(imgMainLeft,imgMainTop){
	imgData=cntxBackBuffer.getImageData(0,0,iw,ih);
	switch(effectSlctr){
	case 0:
	    effFadeIn();
		break;
	case 1:
		effHorizontal();
		break;
	case 2:
	    effVertical();
		break;
	case 3:
	    effRgbEffect();
		break;
	case 4:
	    effCircleEffect();
	    break;
        break;
	}
	//
	cntx.putImageData(imgData,imgMainLeft,imgMainTop);
}

function effFadeIn(){
	imgOpacity+=20;
	if(imgOpacity>255){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=3;i<imgData.data.length;i+=4){
			imgData.data[i]=imgOpacity;
		}
	}
}

function effHorizontal(){
	var noOfPixels=iw*ih;
	visiblePixels+=iw;
	if(visiblePixels>noOfPixels/2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=visiblePixels;i<noOfPixels-visiblePixels;i++){
			imgData.data[4*i+3]=0;
		}
	}
}

function effVertical(){
	visibleColumns+=2;
	if(visibleColumns>iw/2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=0;i<=ih;i++){
			for(var j=visibleColumns;j<=iw-visibleColumns;j++){
				imgData.data[((i-1)*iw+j)*4+3]=0;
			}
		}
	}
}

function effRgbEffect(){
	rgbEffectStage++;
	if(rgbEffectStage>2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=0;i<iw*ih;i++){
			for(var component=rgbEffectStage;component<3;component++){
				imgData.data[4*i+component]=0;
			}
		}
	}
}

function effCircleEffect(){
    effectRadius+=10;
    if(effectRadius>Math.sqrt(Math.pow(iw,2)+Math.pow(ih,2))/radiusDenominatior){
        DrawingFinished=true;
        clearInterval(timerLoop);
    }
    else{
        for(var i=0;i<=ih;i++){
            for(var j=0;j<=iw;j++){
                var r=Math.sqrt(Math.pow(i-yCenterOffset,2)+Math.pow(j-xCenterOffset,2));
                if(r>effectRadius){
                    imgData.data[4*((i-1)*iw+j)+3]=0;
                }
            }
        }
    }
}

function getImagesData(){
    imgData=cntx.getImageData(width+10,10,iw,ih);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (ButtonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function ButtonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseMove(evt){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else {
        imgLogo=document.getElementById("Logo");
        ShowProgramID=false;
    }
    
    for(var i=0;i<NoOfCategories;i++) {
        ButtonHover[i]=false;
        if(my>TopPanelHeight+Column1Top && my<TopPanelHeight+Column1Top+imgButtons[i].height){
            if (mx>=ButtonLeft(i) && mx<=ButtonRight(i)) ButtonHover[i]=true;
        }
    }
    if(DrawingFinished)drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(evt){
    evt.preventDefault();
    isButtonPressed=false;
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        if(MyInfo){
            ShowProgramID=!ShowProgramID;
        }
        else {
            showHTML();
        }
        drawBasicScreen();
    }
    
    if(DrawingFinished){
        var Found=false;

        if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight){
            Found=true;
        }
        
        var i=0;
        while(i<NoOfCategories && !Found){
            if (ButtonHover[i]){
                Found=true;
                SelectedCategory=i;
            }
            else {
                i++;
            }
        }
        if(Found){
            OpaquePercent=0;
            SelectImage(SelectedCategory);
            NextPic=true;
        }
        drawBasicScreen();
    }
}

function SelectImage(i){
    var SelectedFile;
    var AvailableFiles,FileNo;
    if(i==0){
        SelectedFile="Enjoyment";
        AvailableFiles=22;
    }
    else if(i==1){
        SelectedFile="News";
        AvailableFiles=9;
    }
    else if(i==2){
        SelectedFile="Education";
        AvailableFiles=19;
    }
    else{
        SelectedFile="Info";
        AvailableFiles=14;
    }
    do{
        FileNo=parseInt(Math.random()*AvailableFiles+1);
    }while(FileNo==SelectedImage[i] || FileNo>AvailableFiles);
    SelectedImage[i]=FileNo;
    
    var downloadingImage=new Image();
    downloadingImage.onload=function(){
        img.src=this.src;
        iw=img.width;
        ih=img.height;
    	DrawingFinished=false;
    	selectEffect();
        drawBasicScreen();
    };
    
    //φόρτωση επιλεγμένης εικόνας
    downloadingImage.src="img/PIC"+SelectedFile+FileNo+".JPG";
    
    captionToShow=AvailableCaptions[i][FileNo-1];
}

function ShowCaption(){
    if(captionToShow!=""){
        cnvsWrite(LetterColor,16,"Arial",-1,BottomPanelTop+20,Sections[SelectedCategory]);
        cnvsWrite(LetterColor,18,"Arial",-1,BottomPanelTop+42,captionToShow);
    }
}

function InitialiseCaptions(){
    Sections[0]="Ψυχαγωγία";
    Sections[1]="Ενημέρωση";
    Sections[2]="Εκπαίδευση";
    Sections[3]="Πληροφόρηση";
    AvailableCaptions[0][0]="Παίζοντας με τον υπολογιστή";
    AvailableCaptions[0][1]="Ομαδικό παιχνίδι στον υπολογιστή";
    AvailableCaptions[0][2]="Η ψυχαγωγία σε νέες ''διαστάσεις''";
    AvailableCaptions[0][3]="Τηλεόραση μέσα από τον υπολογιστή";
    AvailableCaptions[0][4]="Ένα μοντέρνο σύστημα ψυχαγωγίας";
    AvailableCaptions[0][5]="Ο Υπολογιστής χωρά και στο σαλόνι";
    AvailableCaptions[0][6]="Νέες δυνατότητες στην ψυχαγωγία χάρη στον υπολογιστή";
    AvailableCaptions[0][7]="Ένα μοντέρνο σύστημα επεξεργασίας εικόνας";
    AvailableCaptions[0][8]="Οικιακή ψυχαγωγία επαγγελματικών προδιαγραφών";
    AvailableCaptions[0][9]="Ηλεκτρονικά παιχνίδια";
    AvailableCaptions[0][10]="Ψυχαγωγία για... ΟΛΟΥΣ!";
    AvailableCaptions[0][11]="Παιχνίδια δεξιοτήτων";
    AvailableCaptions[0][12]="Μεγάλη ποικιλία για όλους";
    AvailableCaptions[0][13]="Ψυχαγωγία... του αέρα";
    AvailableCaptions[0][14]="Εξέλιξη της κοινωνικής δικτύωσης";
    AvailableCaptions[0][15]="Κοινωνική δικτύωση μέσω υπολογιστή";
    AvailableCaptions[0][16]="Υπολογιστές με σκοπό την ψυχαγωγία";
    AvailableCaptions[0][17]="Ειδικές ηλεκτρονικές κοινότητες";
    AvailableCaptions[0][18]="Ο υπολογιστής ανοίγει νέα ''παράθυρα'' ψυχαγωγίας";
    AvailableCaptions[0][19]="Ηλεκτρονικές κοινότητες ειδικού ενδιαφέροντος";
    AvailableCaptions[0][20]="Προέκταση της ψυχαγωγίας σε όλο το σπίτι";
    AvailableCaptions[0][21]="Ο υπολογιστής συμβάλλει στην επικοινωνία";
    AvailableCaptions[1][0]="Ενημέρωση στην παλάμη του χεριού μας";
    AvailableCaptions[1][1]="Ενημέρωση στην παλάμη του χεριού μας";
    AvailableCaptions[1][2]="Η ενημέρωση είναι η κύρια χρήση του Internet για τους περισσότερους";
    AvailableCaptions[1][3]="Ενημέρωση από την οθόνη του υπολογιστή";
    AvailableCaptions[1][4]="Διεθνής ενημέρωση";
    AvailableCaptions[1][5]="Η εφημερίδα συναντά τον υπολογιστή";
    AvailableCaptions[1][6]="Ενημέρωση με το πάτημα ενός κουμπιού";
    AvailableCaptions[1][7]="Το Internet ως πηγή ενημέρωσης σταδιακά κερδίζει τα παραδοσιακά μέσα";
    AvailableCaptions[1][8]="Η οθόνη του υπολογιστή παράθυρο στην ενημέρωση";
    AvailableCaptions[2][0]="Πόσα βιβλία ''χωράνε'' σε έναν υπολογιστή;";
    AvailableCaptions[2][1]="Ο νέος πίνακας διδασκαλίας";
    AvailableCaptions[2][2]="Η εκπαίδευση στο Internet";
    AvailableCaptions[2][3]="Εκπαίδευση με το πάτημα ενός κουμπιού";
    AvailableCaptions[2][4]="Εκπαίδευση με το πάτημα ενός κουμπιού";
    AvailableCaptions[2][5]="Εκπαίδευση για όλες τις ηλικίες";
    AvailableCaptions[2][6]="Εκπαίδευση από απόσταση";
    AvailableCaptions[2][7]="Ηλεκτρονική μάθηση";
    AvailableCaptions[2][8]="Το Internet μάς ανοίγει νέα ''παράθυρα'' στη γνώση";
    AvailableCaptions[2][9]="Ψηφιακή τάξη";
    AvailableCaptions[2][10]="Εκπαίδευση για όλους";
    AvailableCaptions[2][11]="Εκπαίδευση μέσω Internet";
    AvailableCaptions[2][12]="Ηλεκτρονικό σχολείο";
    AvailableCaptions[2][13]="Ο υπολογιστής οδηγεί στη γνώση";
    AvailableCaptions[2][14]="Εκπαίδευση για ''μαθητες'' όλων των ειδών";
    AvailableCaptions[2][15]="Ιστο-τάξη";
    AvailableCaptions[2][16]="Μάθηση με το πάτημα ενός κουμπιού";
    AvailableCaptions[2][17]="Η δύναμη του Internet στην υπηρεσία της εκπαίδευσης";
    AvailableCaptions[2][18]="Εμπλουτισμός της μάθησης με νέα εποπτικά μέσα";
    AvailableCaptions[3][0]="Παγκόσμια πληροφόρηση";
    AvailableCaptions[3][1]="Η πληροφορία ταξιδεύει με μεγάλες ταχύτητες";
    AvailableCaptions[3][2]="Πληροφόρηση με το πάτημα ενός κουμπιού";
    AvailableCaptions[3][3]="Ηλεκτρονική πληροφόρηση";
    AvailableCaptions[3][4]="Πληροφόρηση με το πάτημα ενός κουμπιού";
    AvailableCaptions[3][5]="Ο ψηφιακός χάρτης διακίνησης της πληροφορίας";
    AvailableCaptions[3][6]="Ψηφιακή πληροφόρηση για τον άνθρωπο της Ψηφιακής Εποχής";
    AvailableCaptions[3][7]="Πολλές πηγές πληροφόρησης άμεσα διαθέσιμες";
    AvailableCaptions[3][8]="Συνεχής ροή πληροφοριών προς και από κάθε κατεύθυνση";
    AvailableCaptions[3][9]="Ηλεκτρονικές εγκυκλοπαίδεις διαθέσιμες μέσω Internet";
    AvailableCaptions[3][10]="Ο άνθρωπος της ψηφιακής εποχής";
    AvailableCaptions[3][11]="Δίκτυα πληροφόρησης για κάθε είδος ανάγκης";
    AvailableCaptions[3][12]="Ψηφιακός πλανήτης";
    AvailableCaptions[3][13]="Ψηφιακές ευκολίες για τον άνθρωπο της Ψηφιακής Εποχής";
}

function ButtonLeft(i){
    return Column1Left+i*imgButtons[i].width;
}

function ButtonRight(i){
    return Column1Left+(i+1)*imgButtons[i].width;
}

function selectEffect(){
    //Επιλογή εφφέ
    effectSlctr=parseInt(Math.random()*noOfEffects);
    //Αρχικοποίηση παραμέτρων
    imgOpacity=0;
    visiblePixels=0;
    visibleColumns=0;
    rgbEffectStage=-1;
    effectRadius=0;
    simSpeed=10;
    switch(effectSlctr){
        case 3: //rgb
            simSpeed=200;
            break;
        case 4: //circle
            var centerSlctr=Math.random();
            if(centerSlctr<0.33){
                xCenterOffset=0;
                yCenterOffset=0;
                radiusDenominatior=1;
            }
            else if(centerSlctr<0.66){
                xCenterOffset=iw/2;
                yCenterOffset=ih/2;
                radiusDenominatior=2;
            }
            else{
                xCenterOffset=iw;
                yCenterOffset=ih;
                radiusDenominatior=1;
            }
            break;
    }
}